#include "GL_RendererTexturingVisitor.h"
#include "GL_ImageTexture.h"
#include "GL_TextureTransform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

RendererTexturingVisitor::RendererTexturingVisitor()
: TexturingVisitor()
{
  // Enter functions.
  define(Recorder<ImageTexture>::getEnterFunction(&RendererTexturingVisitor::enterImageTexture));
  define(Recorder<TextureTransform>::getEnterFunction(&RendererTexturingVisitor::enterTextureTransform));
}

void RendererTexturingVisitor::enterImageTexture(ImageTexture *I) 
{
  RendererStateVariables *stateVariables = Singleton<RendererStateVariables>::getInstance();
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glBindTexture(GL_TEXTURE_2D, I->getTexName());
  
  glMatrixMode(GL_TEXTURE);
  glLoadMatrixf(I->getTextureTransform());
}

void RendererTexturingVisitor::enterTextureTransform(TextureTransform *T) 
{
  RendererStateVariables *stateVariables = Singleton<RendererStateVariables>::getInstance();
  glMatrixMode(GL_TEXTURE);
  glMultMatrixf(&T->getTransformMatrix().front());
}

}
}
