#include "GL_Updater.h"
#include "DFSGraphTraversal.h"
#include "GL_UpdaterCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Updater::Updater()
: X3DUpdater()
{
  stateVariables = Singleton<UpdaterStateVariables>::getInstance();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new UpdaterCoreVisitor());
}

Updater::~Updater()
{
  Singleton<UpdaterStateVariables>::removeInstance();

  delete graphTraversal;
}

void Updater::update(X3DNode *N)
{
  graphTraversal->traverse(N);
}

}
}
