#include "X3D_GLBuilderTexturingVisitor.h"
#include "X3D_ImageTexture.h"
#include "X3D_TextureTransform.h"
#include "GL_ImageTexture.h"
#include "GL_TextureTransform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

GLBuilderTexturingVisitor::GLBuilderTexturingVisitor()
: TexturingVisitor()
{
  // Enter functions.
  define(Recorder<ImageTexture>::getEnterFunction(&GLBuilderTexturingVisitor::enterImageTexture));
  define(Recorder<TextureTransform>::getEnterFunction(&GLBuilderTexturingVisitor::enterTextureTransform));
}

void GLBuilderTexturingVisitor::enterImageTexture(ImageTexture *I) 
{
  GLBuilderStateVariables *stateVariables = Singleton<GLBuilderStateVariables>::getInstance();
  GL::ImageTexture *GI = new GL::ImageTexture();
  GI->setX3DReference(I);
  stateVariables->getTop()->addChild(GI);
  stateVariables->pushNode(GI);
}

void GLBuilderTexturingVisitor::enterTextureTransform(TextureTransform *T) 
{
  GLBuilderStateVariables *stateVariables = Singleton<GLBuilderStateVariables>::getInstance();
  GL::TextureTransform *GT = new GL::TextureTransform();
  GT->setX3DReference(T);
  stateVariables->getTop()->addChild(GT);
  stateVariables->pushNode(GT);
}


}
}
