#include "X3D_SceneSaverSetCoreVisitor.h"
#include "X3D_Scene.h"
#include "X3D_X3DNode.h"
#include "X3DTypesToSFString.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

SceneSaverSetCoreVisitor::SceneSaverSetCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  define(Recorder<X3DNode>::getEnterFunction(&SceneSaverSetCoreVisitor::enterX3DNode));
}

void SceneSaverSetCoreVisitor::enterX3DNode(X3DNode *N) 
{
  SceneSaverStateVariables *stateVariables = Singleton<SceneSaverStateVariables>::getInstance();

  if (!stateVariables->findNode(N))
  {
    if ((N->getParentList().size() > 1) && (N->getName() == ""))
      N->setName(stateVariables->generateName());
    
    stateVariables->addNode(N);
  }  
}

}
}
