#include "MemReleaser.h"
#include "DFSGraphTraversal.h"
#include "MemReleaserAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MemReleaser::MemReleaser()
: X3DMemReleaser()
{
  stateVariables = Singleton<MemReleaserStateVariables>::getInstance();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MemReleaserAbstractVisitor());
}

MemReleaser::~MemReleaser()
{
  Singleton<MemReleaserStateVariables>::removeInstance();
  delete graphTraversal;
}

void MemReleaser::release(SFAbstractNode N, bool verbose)
{
  stateVariables->setVerbose(verbose);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

void MemReleaser::init()
{
  stateVariables->init();
}

void MemReleaser::finish()
{
  stateVariables->finish();
}

}
